//determine frequency of particular Dewey Decimal ranges  
void calculateDeweys(int month)
{

  Iterator it = hm.entrySet().iterator();  // Get an iterator
 
  while (it.hasNext()) {
    Map.Entry me = (Map.Entry)it.next();
    String s = (String) me.getKey();
    hm.put(s,0);
    //print(me.getKey() + " is ");
    //println(me.getValue());    
  }
    
  
  //calculate number of items within particular dewey ranges 
  Transaction t;
  for (int i = 0; i < transactions.size(); i++)
  {
    t = (Transaction)transactions.get(i);
    String transactionMonth = t.ckodate.substring(5,7); 
    int mth = Integer.parseInt(transactionMonth);
    
  
    if(mth == month)
    {
      if(hm.containsKey(t.itemtype))
      {
        int count = (Integer)hm.get(t.itemtype); 
        count++; 
        hm.put(t.itemtype,count);
      }
      else
      {
        int one = 1; 
        hm.put(t.itemtype,one);
      }
    }
  }
  
  int counter2 = 0; 
  
  Iterator i = hm.entrySet().iterator();  // Get an iterator
  while (i.hasNext()) 
  {
    Map.Entry me = (Map.Entry)i.next();
    int value = (Integer) me.getValue();   
    interpolators[counter2].target(value); 
    counter2++; 
  }  
  println(counter2);
  

}

public ArrayList loadTransactions()
{
  ArrayList transactions = new ArrayList();

  File[] fileArr = listFiles(dataPath(""));

  for (int fn = 0; fn < fileArr.length; fn++) 
  {
    File f = (File) fileArr[fn];    

    if (!f.getName().endsWith(".txt"))
    {
      continue;
    }

    println("loading file... \"" + f.getName() + "\"");
    String[] lines = loadStrings(f);

    for (int i = 0; i < lines.length; i++)
    {
      transactions.add(parseTransaction(lines[i])); 
    }
  }

  return transactions;
}


// This function returns all the files in a directory as an array of File objects
// This is useful if you want more info about the file
public File[] listFiles(String dir) {
  File file = new File(dir);
  if (file.isDirectory()) {
    File[] files = file.listFiles();
    return files;
  } 
  else {
    // If it's not a directory
    return null;
  }
}

//create a new transaction obejct from a comma separated line.
public Transaction parseTransaction(String line)
{
  String sections[] = split(line, ",");

  Transaction t = new Transaction();

  //store all fields
//  t.itemNumber = sections[0];
//  t.bibNumber = sections[1];
  t.ckodate = sections[0];
//  t.ckotime = sections[3];
//  t.ckidate = sections[4];
//  t.ckitime = sections[5];
//  t.collcode = sections[6];
  t.itemtype = sections[1];
//  t.barcode = sections[8];
//  t.title = sections[9];
//  t.callNumber = sections[10];
  t.deweyClass = sections[2];
  
  if(hm.containsKey(t.itemtype))
  {
     int count = (Integer)hm.get(t.itemtype); 
     count++; 
     hm.put(t.itemtype,count); 
  } 
  else
  {
    int i = 1; 
    hm.put(t.itemtype,i); 
  }
  return t;
}






